<?php

require_once "util.php";

add_action('admin_menu', 'bluengo_admin_main_menu');


function bluengo_admin_main_menu() {

	add_menu_page(
		'Bluengo',
		'Bluengo',
		'edit_posts',
		'bluengo_main',
		'bluengo_main_callback_function',
        plugin_dir_url( __DIR__ ).'img/bluengo_squared_logo_16.png'

	);
}

add_action('admin_post_bluengo_main_form_submit','bluengo_main_callback_function_form_post');

function bluengo_main_callback_function_form_post() {
    global $bluengo_db_version;
    global $wpdb;
    $table_name = $wpdb->prefix . 'bluengo_cache';

    $results = $wpdb->get_results("SELECT * FROM {$table_name} WHERE type = 'install'");

    $install_data = [];
    if (count($results) > 0) {
        $install_data = json_decode(current($results)->data, true);
    }

    if(!empty($_POST["sector"])) {
        $install_data["sector"] = $_POST["sector"];
        $new_install_data = json_encode($install_data);
        $wpdb->escape_by_ref($new_install_data);

        $query = "UPDATE {$table_name} SET data = \"{$new_install_data}\" WHERE type = 'install'";
        $wpdb->query($query);
    }
    wp_redirect(get_admin_url() . "admin.php?page=bluengo_main");
}

add_action('admin_post_bluengo_link_form_submit','bluengo_link_callback_function_form_post');

function bluengo_link_callback_function_form_post() {
    global $bluengo_db_version;
    global $wpdb;
    $table_name = $wpdb->prefix . 'bluengo_cache';

    $results = $wpdb->get_results("SELECT * FROM {$table_name} WHERE type = 'install'");

    $install_data = [];
    if (count($results) > 0) {
        $install_data = json_decode(current($results)->data, true);
        bluengo_url_post_data(BLUENGO_BASE_API_URL . '/v1/tenant/reallocate', array("new_email" => $_POST["email"], "install_data" => $install_data));
    }

    wp_redirect(get_admin_url() . "admin.php?page=bluengo_main");
}

function bluengo_main_callback_function() {
    global $bluengo_db_version;
    global $wpdb;
    $table_name = $wpdb->prefix . 'bluengo_cache';

    $results = $wpdb->get_results("SELECT * FROM {$table_name} WHERE type = 'install'");

    $install_data = null;
    if (count($results) > 0) {
        $install_data = json_decode(current($results)->data, true);
    }
    ?>

    <h1>Bluengo Admin</h1>
    <form method="post" action="admin-post.php">
        <input name='action' type="hidden" value='bluengo_main_form_submit'>
        <table class="form-table">
            <tr>
                <td><label for="tenant_id">Store Sector</label></td>
                <td>
                    <select name="sector" id="sector" required="required">
                        <?php $sectors = require "sectors.php"; ?>
                        <?php
                        foreach ($sectors as $sector) {

                            $selected = '';
                            if ($install_data['sector'] == $sector) {
                                $selected = 'selected';
                            }
                            echo '<option value="' . $sector . '" ' . $selected . '>' . $sector . '</option>';
                        } ?>
                    </select>
                    <input class="button-primary" type="submit" value="<?php _e("Update"); ?>"/>
                </td>
            </tr>
        </table>
    </form>
    <hr/>
    <form method="post" action="admin-post.php">
        <input name='action' type="hidden" value='bluengo_link_form_submit'>
        <table class="form-table">
            <tr>
                <td style="width: 420px;"><label for="bluengo_email">New Bluengo email for admin</label></td>
                <td>
                    <input style="" type="email" name="email" id="bluengo_email">
                    <input class="button-primary" type="submit" value="<?php _e("Link"); ?>"/>
                </td>
            </tr>
        </table>
    </form>
    <table class="form-table">
        <tr>
            <td style="max-width: 420px;"><label for="tenant_id">Tenant ID</label></td>
            <td><input style="" type="text" value="<?php echo implode(',',$install_data['original_tenant_id'])?>" disabled></td>
        </tr>
        <tr>
            <td><label for="tenant_id">Store ID</label></td>
            <td><input style="" type="text" id="tenant_id" value="<?php echo $install_data['uuid']?>" disabled></td>
        </tr>
    </table>

    <?php
}
